#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;

struct vertex
{
    vector<int> next;
};

void bfs(vector<vertex>& G, vector<bool>& used, vector<bool>& ans, int v, int len)
{
    queue<pair<int, int>> Q;
    Q.push({v, 0});

    while (!Q.empty())
    {
        if (used[Q.front().first])
        {
            Q.pop();
            continue;
        }
        used[Q.front().first] = 1;

        if (Q.front().second <= len)
        {
            ans[Q.front().first] = 1;
        }

        if (Q.front().second >= len)
        {
            Q.pop();
            continue;
        }

        for (int i = 0; i < G[Q.front().first].next.size(); i++)
        {
            Q.push({G[Q.front().first].next[i], Q.front().second + 1});
        }
        Q.pop();
    }
}

int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    int n, m, k;
    cin >> n >> m >> k;

    vector<vertex> G(n);
    for (int i = 0; i < m; i++)
    {
        int a, b;
        cin >> a >> b;

        a--; b--;

        G[a].next.push_back(b);
        G[b].next.push_back(a);
    }

    vector<bool> ans(n);
    for (int i = 0; i < k; i++)
    {
        int p, h;
        cin >> p >> h;

        p--;

        vector<bool> used(n, 0);
        bfs(G, used, ans, p, h);
    }

    int c = 0;
    string ans_str = "";

    for (int i = 0; i < n; i++)
    {
        if (ans[i])
        {
            c++;
            ans_str += to_string(i + 1) + " ";
        }
    }

    cout << c << endl << ans_str;

    return 0;
}
